package com.ccnode.codegenerator.U;

package .tmp;

import com.ccnode.codegenerator.U.a;
import com.ccnode.codegenerator.U.b;
import com.ccnode.codegenerator.U.f;
import com.ccnode.codegenerator.k.a;
import com.intellij.formatting.Block;
import com.intellij.formatting.ChildAttributes;
import com.intellij.formatting.Indent;
import com.intellij.formatting.Spacing;
import com.intellij.lang.ASTNode;
import com.intellij.openapi.util.TextRange;
import com.intellij.psi.formatter.common.AbstractBlock;
import com.intellij.psi.formatter.xml.XmlFormattingPolicy;
import com.intellij.psi.tree.IElementType;
import com.intellij.psi.xml.XmlAttribute;
import com.intellij.psi.xml.XmlElementType;
import com.intellij.psi.xml.XmlTag;
import com.intellij.psi.xml.XmlTokenType;
import com.intellij.util.text.CharArrayUtil;
import java.util.List;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class e extends a implements Block {
  private final List<Block> a;
  
  private final Indent b;
  
  public e(List<Block> paramList, Block paramBlock, Indent paramIndent1, XmlFormattingPolicy paramXmlFormattingPolicy, Indent paramIndent2) {
    super(paramList, paramBlock, paramXmlFormattingPolicy, paramIndent1);
    this.a = paramList;
    this.b = paramIndent2;
  }
  
  @NotNull
  public TextRange getTextRange() {
    return a(this.a);
  }
  
  @NotNull
  public List<Block> getSubBlocks() {
    return this.a;
  }
  
  public Spacing getSpacing(Block paramBlock1, @NotNull Block paramBlock2) {
    if (paramBlock1 instanceof com.ccnode.codegenerator.U.n || paramBlock2 instanceof com.ccnode.codegenerator.U.n)
      return Spacing.getReadOnlySpacing(); 
    if (!(paramBlock1 instanceof b) || !(paramBlock2 instanceof b))
      return null; 
    boolean bool1 = a.a().getInsertNewLineAfterInclude();
    if (bool1 && 
      paramBlock2 instanceof com.ccnode.codegenerator.U.c) {
      XmlTag xmlTag = ((b)paramBlock1).a();
      if (xmlTag != null) {
        String str = xmlTag.getName();
        if (str.equals("include"))
          return Spacing.createSpacing(0, 2147483647, 1, true, this.a.getKeepBlankLines()); 
      } 
    } 
    ASTNode aSTNode1 = ((AbstractBlock)paramBlock1).getNode();
    ASTNode aSTNode2 = ((AbstractBlock)paramBlock2).getNode();
    IElementType iElementType1 = aSTNode1.getElementType();
    IElementType iElementType2 = aSTNode2.getElementType();
    if (iElementType2 == XmlElementType.XML_COMMENT)
      return Spacing.createSpacing(0, 2147483647, 0, true, this.a.getKeepBlankLines()); 
    if (iElementType1 == XmlElementType.XML_COMMENT) {
      ASTNode aSTNode = aSTNode1.getTreePrev();
      if (aSTNode != null) {
        aSTNode1 = aSTNode;
        iElementType1 = aSTNode.getElementType();
      } 
    } 
    boolean bool2 = a(aSTNode1);
    boolean bool3 = a(aSTNode2);
    if (((b)paramBlock1).a() && ((b)paramBlock2).a()) {
      ASTNode aSTNode = aSTNode1.getTreeParent();
      boolean bool = (aSTNode != null && aSTNode.getTreePrev().getElementType() == XmlTokenType.XML_TAG_END) ? true : false;
      if (bool)
        return Spacing.getReadOnlySpacing(); 
    } 
    if (iElementType1 == XmlTokenType.XML_CDATA_START || iElementType2 == XmlTokenType.XML_CDATA_END) {
      if (this.a.getKeepWhiteSpacesInsideCDATA())
        return Spacing.getReadOnlySpacing(); 
      if (iElementType1 == XmlTokenType.XML_CDATA_START && iElementType2 == XmlTokenType.XML_CDATA_END)
        return Spacing.createSpacing(0, 0, 0, this.a.getShouldKeepLineBreaks(), this.a.getKeepBlankLines()); 
      if ((iElementType1 == XmlTokenType.XML_CDATA_START && paramBlock2 instanceof com.ccnode.codegenerator.U.c) || (iElementType2 == XmlTokenType.XML_CDATA_END && paramBlock1 instanceof com.ccnode.codegenerator.U.c))
        return Spacing.createSpacing(0, 0, 1, this.a.getShouldKeepLineBreaks(), 0); 
    } 
    boolean bool4 = (aSTNode1.getPsi() instanceof XmlTag && !bool2) ? true : false;
    boolean bool5 = (aSTNode2.getPsi() instanceof XmlTag && !bool3) ? true : false;
    boolean bool6 = b(aSTNode1);
    boolean bool7 = b(aSTNode2);
    if (((bool3 && c(aSTNode1)) || (bool2 && c(aSTNode2))) && this.a
      .isKeepSpacesAroundInlineTags())
      return Spacing.getReadOnlySpacing(); 
    if (a(bool4, bool5, bool2, bool3) && r())
      return Spacing.getReadOnlySpacing(); 
    if (bool6 || bool7)
      return Spacing.createSafeSpacing(this.a.getShouldKeepLineBreaks(), this.a.getKeepBlankLines()); 
    if (a(iElementType1) && (iElementType2 == XmlTokenType.XML_TAG_END || iElementType2 == XmlTokenType.XML_EMPTY_ELEMENT_END)) {
      Spacing spacing = this.a.getSpacingAfterLastAttribute((XmlAttribute)aSTNode1.getPsi());
      if (spacing != null)
        return spacing; 
    } 
    if (iElementType2 == XmlTokenType.XML_EMPTY_ELEMENT_END && this.a.addSpaceIntoEmptyTag())
      return Spacing.createSpacing(1, 1, 0, this.a
          .getShouldKeepLineBreaks(), this.a
          .getKeepBlankLines()); 
    if (a(iElementType1, iElementType2)) {
      boolean bool = a(aSTNode1, aSTNode2) ? true : false;
      return Spacing.createSpacing(bool, bool, 0, this.a.getShouldKeepLineBreaks(), this.a.getKeepBlankLines());
    } 
    if (a(iElementType2)) {
      if (iElementType1 == XmlTokenType.XML_NAME || iElementType1 == XmlTokenType.XML_TAG_NAME) {
        Spacing spacing = this.a.getSpacingBeforeFirstAttribute((XmlAttribute)aSTNode2.getPsi());
        if (spacing != null)
          return spacing; 
      } 
      return Spacing.createSpacing(1, 1, 0, this.a.getShouldKeepLineBreaks(), this.a.getKeepBlankLines());
    } 
    if (iElementType1 == XmlTokenType.XML_DATA_CHARACTERS && iElementType2 == XmlTokenType.XML_DATA_CHARACTERS)
      return Spacing.createSpacing(1, 1, 0, this.a
          .getShouldKeepLineBreaksInText(), this.a.getKeepBlankLines()); 
    if (((b)paramBlock1).d() && ((b)paramBlock2).d())
      return Spacing.createSafeSpacing(this.a.getShouldKeepLineBreaksInText(), this.a.getKeepBlankLines()); 
    if (bool4 && a((XmlTag)aSTNode1.getPsi()))
      return Spacing.createSpacing(0, 0, 1, true, this.a.getKeepBlankLines()); 
    if ((bool2 || bool4) && bool5) {
      if (((b)paramBlock2).b())
        return Spacing.createSpacing(0, 2147483647, ((b)paramBlock2)
            .a() + 1, this.a
            .getShouldKeepLineBreaks(), this.a
            .getKeepBlankLines()); 
      if (((b)paramBlock2).c())
        return Spacing.createSpacing(0, 2147483647, 0, this.a.getShouldKeepLineBreaks(), this.a
            .getKeepBlankLines()); 
    } 
    boolean bool8 = (this.a.shouldSaveSpacesBetweenTagAndText() && paramBlock1.getTextRange().getEndOffset() < paramBlock2.getTextRange().getStartOffset()) ? true : false;
    if (bool4 && bool3) {
      if (((b)paramBlock1).d() || bool8)
        return Spacing.createSafeSpacing(true, this.a.getKeepBlankLines()); 
      return Spacing.createSpacing(0, 0, 0, true, this.a.getKeepBlankLines());
    } 
    if (bool2 && bool5) {
      if (((b)paramBlock2).d() || bool8)
        return Spacing.createSafeSpacing(true, this.a.getKeepBlankLines()); 
      return Spacing.createSpacing(0, 0, 0, true, this.a.getKeepBlankLines());
    } 
    if (bool4 && bool5)
      return Spacing.createSpacing(0, 2147483647, 0, true, this.a
          .getKeepBlankLines()); 
    return Spacing.createSpacing(0, 2147483647, 0, this.a.getShouldKeepLineBreaksInText(), this.a.getKeepBlankLines());
  }
  
  private boolean b(ASTNode paramASTNode) {
    return (paramASTNode.getElementType() == XmlElementType.XML_ENTITY_REF || paramASTNode.getElementType() == XmlTokenType.XML_CHAR_ENTITY_REF);
  }
  
  private boolean a(ASTNode paramASTNode1, ASTNode paramASTNode2) {
    if (paramASTNode1.getElementType() == XmlTokenType.XML_START_TAG_START && paramASTNode1.textContains('%'))
      return true; 
    if (paramASTNode2.getElementType() == XmlTokenType.XML_EMPTY_ELEMENT_END && paramASTNode2.textContains('%'))
      return true; 
    return this.a.getShouldAddSpaceAroundTagName();
  }
  
  private boolean a(boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, boolean paramBoolean4) {
    return ((paramBoolean3 && paramBoolean4) || (paramBoolean1 && paramBoolean2) || (paramBoolean1 && paramBoolean4) || (paramBoolean3 && paramBoolean2));
  }
  
  private boolean r() {
    return (this.a.keepWhiteSpacesInsideTag(a()) || this.a.getShouldKeepWhiteSpaces());
  }
  
  protected boolean a(ASTNode paramASTNode) {
    ASTNode aSTNode = paramASTNode.getTreeParent();
    return ((aSTNode != null && aSTNode.getElementType() == XmlElementType.XML_TEXT) || paramASTNode
      .getElementType() == XmlTokenType.XML_DATA_CHARACTERS);
  }
  
  @NotNull
  public ChildAttributes getChildAttributes(int paramInt) {
    if (l())
      return ChildAttributes.DELEGATE_TO_NEXT_CHILD; 
    List<Block> list = getSubBlocks();
    int i = paramInt - 1;
    if (i >= 0 && i < list.size()) {
      Block block = list.get(paramInt - 1);
      if (a(block))
        return new ChildAttributes(this.b, block.getAlignment()); 
    } 
    return new ChildAttributes(this.b, null);
  }
  
  private boolean a(Block paramBlock) {
    if (paramBlock instanceof f)
      return a(((f)paramBlock).getNode().getElementType()); 
    return false;
  }
  
  public boolean isIncomplete() {
    return ((Block)getSubBlocks().get(getSubBlocks().size() - 1)).isIncomplete();
  }
  
  public boolean q() {
    return a(getSubBlocks().get(getSubBlocks().size() - 1));
  }
  
  public Indent a() {
    return this.b;
  }
  
  private static boolean c(@NotNull ASTNode paramASTNode) {
    return (paramASTNode.getElementType() == XmlElementType.XML_TAG && f(paramASTNode) && 
      d(paramASTNode.getTreePrev()) && e(paramASTNode.getTreeNext()));
  }
  
  private static boolean d(@Nullable ASTNode paramASTNode) {
    if (paramASTNode != null && paramASTNode.getElementType() == XmlElementType.XML_TEXT) {
      ASTNode aSTNode = paramASTNode.getLastChildNode();
      if (aSTNode != null)
        return (!(aSTNode.getPsi() instanceof com.intellij.psi.PsiWhiteSpace) || !CharArrayUtil.containLineBreaks(aSTNode.getChars())); 
    } 
    return false;
  }
  
  private static boolean e(@Nullable ASTNode paramASTNode) {
    if (paramASTNode != null && paramASTNode.getElementType() == XmlElementType.XML_TEXT) {
      ASTNode aSTNode = paramASTNode.getFirstChildNode();
      if (aSTNode != null)
        return (!(aSTNode.getPsi() instanceof com.intellij.psi.PsiWhiteSpace) || !CharArrayUtil.containLineBreaks(aSTNode.getChars())); 
    } 
    return false;
  }
  
  private static boolean f(@NotNull ASTNode paramASTNode) {
    ASTNode aSTNode = paramASTNode.getFirstChildNode();
    boolean bool = false;
    while (aSTNode != null) {
      IElementType iElementType = aSTNode.getElementType();
      if (bool) {
        if (iElementType == XmlTokenType.XML_END_TAG_START)
          return true; 
        if (iElementType != XmlElementType.XML_TEXT)
          return false; 
      } else if (iElementType == XmlTokenType.XML_TAG_END) {
        bool = true;
      } 
      aSTNode = aSTNode.getTreeNext();
    } 
    return false;
  }
}
